<?php
require 'includes/application_top.php';

function build_sql_query(string $table_name, array $table_fields)
{
    $looking_for = [
        'FAKE ACCOUNT',
        '\_src\_',
        '\_scrpt\_',
        'SPAM MESSAGE',
    ];

    $sql =
        "SELECT *
           FROM $table_name
          WHERE ";
    foreach ($table_fields as $field_name) {
        foreach ($looking_for as $next_match) {
            $sql .= "$field_name LIKE '%$next_match%' OR ";
        }
    }
    return substr($sql, 0, -3); //- Strip trailing 'OR '
}

function output_result(bool $is_error)
{
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Zen Cart SPAM Cleanup Check</title>
</head>
<body>
<?php
    if ($is_error === false) {
?>
    <h1 style="color: green; text-align: center;">No SPAM accounts or messages were found.</h1>
<?php
    } else {
?>
    <h1 style="color: red; text-align: center;">One or more SPAM accounts found, you should change all admin passwords and your admin directory name.</h1>
<?php
    }
?>
</body>
</html>
<?php
    require DIR_WS_INCLUDES . 'application_bottom.php';
    exit();
}

$customers_fields = [
    'customers_firstname',
    'customers_lastname',
    'customers_nick',
    'customers_telephone',
    'customers_fax',
    'customers_referral',
    'customers_email_address',
];
$customers_sql = build_sql_query(TABLE_CUSTOMERS, $customers_fields);
$customers_result = $db->Execute($customers_sql);
$customers_issues = (int)$customers_result->RecordCount();
if ($customers_issues !== 0) {
    output_result(true);
}

$address_fields = [
    'entry_company',
    'entry_firstname',
    'entry_lastname',
    'entry_street_address',
    'entry_suburb',
    'entry_city',
    'entry_state',
];
$address_book_sql = build_sql_query(TABLE_ADDRESS_BOOK, $address_fields);
$address_book_result = $db->Execute($address_book_sql);
$address_book_issues = (int)$address_book_result->RecordCount();
if ($address_book_issues !== 0) {
    output_result(true);
}

$orders_fields = [
    'customers_company',
    'customers_name',
    'customers_street_address',
    'customers_suburb',
    'customers_city',
    'customers_state',
    'customers_country',
    'customers_telephone',
    'delivery_company',
    'delivery_name',
    'delivery_street_address',
    'delivery_suburb',
    'delivery_city',
    'delivery_state',
    'delivery_country',
    'billing_company',
    'billing_name',
    'billing_street_address',
    'billing_suburb',
    'billing_city',
    'billing_state',
    'billing_country',
];
$orders_sql = build_sql_query(TABLE_ORDERS, $orders_fields);
$orders_result = $db->Execute($orders_sql);
$orders_issues = (int)$orders_result->RecordCount();
if ($orders_issues !== 0) {
    output_result(true);
}

$email_archive_fields = [
    'email_subject',
    'email_to_name',
    'email_text',
    'email_html',
];
$email_archive_sql = build_sql_query(TABLE_EMAIL_ARCHIVE, $email_archive_fields);
$email_archive_result = $db->Execute($email_archive_sql);
$email_archive_issues = (int)$email_archive_result->RecordCount();
if ($email_archive_issues !== 0) {
    output_result(true);
}

output_result(false);
